using System;
using System.Diagnostics;
using System.ComponentModel;
using System.Data;
using System.Windows.Forms;
using System.Collections;

using Syncfusion.Windows.Forms.Chart;

namespace Syncfusion.Windows.Forms.Chart.Samples
{	
	/// <summary>
	/// Summary description for SimpleModel.
	/// </summary>
	public class DateArrayModel : IChartSeriesModel
	{
		private ArrayList xdata = new ArrayList();
		private ArrayList ydata = new ArrayList();

		public DateArrayModel()
		{
		}

		public int Count 
		{ 
			get
			{
				try
				{
					return this.xdata.Count;
				}
				catch(Exception e)
				{
					Console.WriteLine(e.Message);
				}

				return 0;
			}
		}
		

		public double[] GetY(int index)
		{
			try
			{
				return (double[])ydata[index];
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message + " " +  this.xdata.Count.ToString());
			}

			return new double[]{0};
		}

		public double GetX(int index)
		{
			try
			{
				return (double) xdata[index];
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message + " " +  this.xdata.Count.ToString());
			}

			return 0;
		}

		public void RaiseListChanged()
		{
			if(this.Changed != null)
				this.Changed(this,new ListChangedEventArgs(ListChangedType.Reset,-1));
		}

		public void AddXY(double xval, double[] yvalues)
		{
			xdata.Add(xval);
			ydata.Add(yvalues);
			this.RaiseListChanged();
		}

		public bool GetEmpty(int index)
		{
			return false;
		}

		public event ListChangedEventHandler Changed;
	}
}