using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Chart;

namespace Syncfusion.Windows.Forms.Chart.Samples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		private System.Windows.Forms.Timer timer1;
		private System.ComponentModel.IContainer components;

		DateTime lastTime = DateTime.Now;
		private System.Windows.Forms.CheckBox checkBox1;
		DateTime lastFirstPoint = DateTime.Now;

		double[] points = {   0.000001,0.00081, 0.00087, 0.003, 0.00067,0.078,0.3456,1.2, 567.89, 1.89, 1.99,7.89,9989};

		private DateArrayModel model = new DateArrayModel();


		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
			this.timer1 = new System.Windows.Forms.Timer(this.components);
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.SuspendLayout();
			// 
			// chartControl1
			// 
			this.chartControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			// 
			// chartControl1.ChartArea
			// 
			this.chartControl1.ChartArea.BackColor = System.Drawing.Color.White;
			this.chartControl1.ChartArea.BackImage = null;
			this.chartControl1.ChartArea.ChartAreaToolTip = "";
			this.chartControl1.ChartArea.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
			this.chartControl1.Depth = 1F;
			this.chartControl1.HidePartialLabels = false;
			// 
			// chartControl1.Legend
			// 
			this.chartControl1.Name = "chartControl1";
			this.chartControl1.PrimaryXAxis.Orientation = System.Windows.Forms.Orientation.Horizontal;
			this.chartControl1.PrimaryXAxis.ZoomFactor = 1;
			this.chartControl1.PrimaryXAxis.ZoomPosition = 0;
			this.chartControl1.PrimaryYAxis.ZoomFactor = 1;
			this.chartControl1.PrimaryYAxis.ZoomPosition = 0;
			this.chartControl1.Rotation = 0.1F;
			this.chartControl1.Series3D = false;
			this.chartControl1.ShadowColor = new Syncfusion.Drawing.BrushInfo(System.Drawing.Color.FromArgb(((System.Byte)(155)), ((System.Byte)(169)), ((System.Byte)(169)), ((System.Byte)(169))));
			this.chartControl1.Size = new System.Drawing.Size(784, 470);
			this.chartControl1.Spacing = 10F;
			this.chartControl1.TabIndex = 0;
			this.chartControl1.Text = "Syncfusion Essential Chart";
			this.chartControl1.Tilt = 0.1F;
			// 
			// timer1
			// 
			this.timer1.Interval = 200;
			this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
			// 
			// checkBox1
			// 
			this.checkBox1.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.checkBox1.Checked = true;
			this.checkBox1.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBox1.Location = new System.Drawing.Point(800, 32);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.Size = new System.Drawing.Size(128, 24);
			this.checkBox1.TabIndex = 1;
			this.checkBox1.Text = "Scrolling";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(896, 470);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.checkBox1,
																		  this.chartControl1});
			this.Name = "Form1";
			this.Text = "Chart Real Time";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			InitializeChart();	
		}

		protected void InitializeChart()
		{
			// Set Indexed to false as we will be using non indexed data
			this.chartControl1.Indexed = false;

			// Create a series
			ChartSeries series = this.chartControl1.Model.NewSeries("Products");
			series.Text = series.Name;
			series.SeriesModelImpl = this.model;
			series.Type = ChartSeriesType.Line;
			series.Style.DisplayShadow = false;
			series.Style.DisplayText = true;
			this.chartControl1.Series.Add(series);

			this.chartControl1.PrimaryXAxis.ValueType = ChartValueType.DateTime;
			this.chartControl1.PrimaryXAxis.DateTimeFormat = "hh:mm:ss";
			this.chartControl1.PrimaryXAxis.DrawGrid = false;
			this.chartControl1.PrimaryXAxis.RoundingPlaces = 12;
			this.chartControl1.PrimaryXAxis.LabelIntersectAction = ChartLabelIntersectAction.Rotate;

			this.chartControl1.PrimaryYAxis.DrawGrid = false;

			this.chartControl1.Legend.Visible = false;

			this.timer1.Start();

		}

		private void timer1_Tick(object sender, System.EventArgs e)
		{
			try
			{
				Random rand = new Random();
				DateTime currentFirstPoint = DateTime.Now;
									
				// Add 10 points each time					
				for(int i =0; i < 10; i++)
				{

						DateTime current = lastTime.AddSeconds(20);
					this.model.AddXY(current.ToOADate(), new double[]{points[rand.Next(0,13)]});

						if(i == 0)
							currentFirstPoint = current;

						lastTime = current;
					}

					TimeSpan range = this.chartControl1.PrimaryXAxis.DateTimeRange.End - this.chartControl1.PrimaryXAxis.DateTimeRange.Start;
					double rangeMilliSeconds = range.TotalMilliseconds;

					TimeSpan lastGap = this.chartControl1.PrimaryXAxis.DateTimeRange.End - lastTime;
					TimeSpan endGap = lastTime - lastFirstPoint;
					double timeWindowMilliSeconds = 0;
					timeWindowMilliSeconds = endGap.TotalMilliseconds;
					if(rangeMilliSeconds > timeWindowMilliSeconds && this.checkBox1.Checked)
					{
						this.chartControl1.ZoomFactorX = timeWindowMilliSeconds/rangeMilliSeconds;
						this.chartControl1.ZoomPositionX = 1 - this.chartControl1.ZoomFactorX - (lastGap.TotalMilliseconds)/rangeMilliSeconds;
					}

					lastFirstPoint = currentFirstPoint;
			}
			catch(Exception ex)
			{
				Console.WriteLine(ex.ToString());
			}
		}
	}
}
